Loading...
Searching...
No Matches
casacore::LELAttribute Class Reference
lattices package (libcasa_lattices) » LEL_module » LEL_module_internal_classes

More...

`#include <LELAttribute.h>`

## Public Member Functions

| LELAttribute ()
| Default constructor sets it as a scalar.
| LELAttribute (Bool isMasked, const IPosition &shape, const IPosition &tileShape, const LELCoordinates &coordinates, Bool isReduced=False)
| Constructor sets it as lattice with given attributes.
| LELAttribute (uInt regionNdim)
| Constructor sets it as a region with given attributes.
| LELAttribute (const LELAttribute &attr)
| Copy constructor (copy semantics).
| LELAttribute (const LELAttribute &attrLeft, const LELAttribute &attrRight, Bool matchAxes=True)
| Constructor that combines the two attributes given.
| ~LELAttribute ()
| Destructor.
LELAttribute & | operator= (const LELAttribute &other)
| Assignment (copy semantics).
Bool | isScalar () const
| Is expression a scalar?
Bool | isReduced () const
| Is expression a reduced array?
Bool | isRegion () const
| Is expression a region?
Bool | isMasked () const
| Is the expression result masked?
const IPosition & | shape () const
| What is the shape of the expression?
const IPosition & | tileShape () const
| What is the tile shape of the expression?
const LELCoordinates & | coordinates () const
| What are the coordinates of the expression?
Int | compareCoord (const LELAttribute &other) const
| Compare the coordinates and shapes to see if this is a subset of other.

## Private Attributes

Bool | isScalar_p
Bool | isReduced_p
Bool | isRegion_p
Bool | isMasked_p
IPosition | shape_p
IPosition | tileShape_p
LELCoordinates | coords_p

## Detailed Description

Ancillary information for the LEL letter classes.

### Intended use:

Internal

### Review Status

Date Reviewed:
  yyyy/mm/dd

### Prerequisite

- Lattice
- LatticeExpr
- LatticeExprNode
- LELInterface and derived classes

### Etymology

Holds attribute information for the Lattice Expression Language letter classes.

### Synopsis

The Lattice Expression Language letter classes provide expression objects. There is ancilliary information or attributes associated with these objects:

- Scalar or lattice (i.e. array) or region.
- In case of an array, is it a reduced array. I.e. is it an array that has to be calculated beforehand (e.g. partialMax). A scalar is always reduced.
- Shape and tile shape of a lattice. This can be undefined.
- Is the lattice masked?
- Optionally coordinates of the lattice.

Two attribute objects can be combined mirroring the combination of two expressions (like the addition of two lattices). Regions cannot be combined.

Definition at line 79 of file LELAttribute.h.

## Constructor & Destructor Documentation

## LELAttribute() [1/5]

casacore::LELAttribute::LELAttribute | ( |  | ) |

Default constructor sets it as a scalar.

Referenced by compareCoord(), LELAttribute(), LELAttribute(), and operator=().

## LELAttribute() [2/5]

casacore::LELAttribute::LELAttribute | ( | Bool | isMasked,
|  | const IPosition & | shape,
|  | const IPosition & | tileShape,
|  | const LELCoordinates & | coordinates,
|  | Bool | isReduced = False )

Constructor sets it as lattice with given attributes.

An empty shape indicates that the shape is not known.

References coordinates(), casacore::False, isMasked(), isReduced(), shape(), and tileShape().

## LELAttribute() [3/5]

casacore::LELAttribute::LELAttribute | ( | uInt | regionNdim | ) |

explicit

Constructor sets it as a region with given attributes.

## LELAttribute() [4/5]

casacore::LELAttribute::LELAttribute | ( | const LELAttribute & | attr | ) |

Copy constructor (copy semantics).

References LELAttribute().

## LELAttribute() [5/5]

casacore::LELAttribute::LELAttribute | ( | const LELAttribute & | attrLeft,
|  | const LELAttribute & | attrRight,
|  | Bool | matchAxes = True )

Constructor that combines the two attributes given.

An array can be combined with a scalar. If matchAxes is True and if two arrays are given, the shapes and coordinates have to match exactly, otherwise one can be a subset of the other (and LEL will auto-extend).

References LELAttribute(), and casacore::True.

## ~LELAttribute()

casacore::LELAttribute::~LELAttribute | ( |  | ) |

Destructor.

## Member Function Documentation

## compareCoord()

Int casacore::LELAttribute::compareCoord | ( | const LELAttribute & | other | ) | const

Compare the coordinates and shapes to see if this is a subset of other.

References LELAttribute().

## coordinates()

const LELCoordinates & casacore::LELAttribute::coordinates | ( |  | ) | const

inline

What are the coordinates of the expression?

Definition at line 133 of file LELAttribute.h.

References coords_p.

Referenced by LELAttribute().

## isMasked()

Bool casacore::LELAttribute::isMasked | ( |  | ) | const

inline

Is the expression result masked?

Definition at line 124 of file LELAttribute.h.

References isMasked_p.

Referenced by LELAttribute().

## isReduced()

Bool casacore::LELAttribute::isReduced | ( |  | ) | const

inline

Is expression a reduced array?

A scalar is always reduced.

Definition at line 118 of file LELAttribute.h.

References isReduced_p.

Referenced by LELAttribute().

## isRegion()

Bool casacore::LELAttribute::isRegion | ( |  | ) | const

inline

Is expression a region?

Definition at line 121 of file LELAttribute.h.

References isRegion_p.

## isScalar()

Bool casacore::LELAttribute::isScalar | ( |  | ) | const

inline

Is expression a scalar?

Definition at line 115 of file LELAttribute.h.

References isScalar_p.

## operator=()

LELAttribute & casacore::LELAttribute::operator= | ( | const LELAttribute & | other | ) |

Assignment (copy semantics).

References LELAttribute().

## shape()

const IPosition & casacore::LELAttribute::shape | ( |  | ) | const

inline

What is the shape of the expression?

Definition at line 127 of file LELAttribute.h.

References shape_p.

Referenced by LELAttribute().

## tileShape()

const IPosition & casacore::LELAttribute::tileShape | ( |  | ) | const

inline

What is the tile shape of the expression?

Definition at line 130 of file LELAttribute.h.

References tileShape_p.

Referenced by LELAttribute().

## Member Data Documentation

## coords_p

LELCoordinates casacore::LELAttribute::coords_p

private

Definition at line 145 of file LELAttribute.h.

Referenced by coordinates().

## isMasked_p

Bool casacore::LELAttribute::isMasked_p

private

Definition at line 142 of file LELAttribute.h.

Referenced by isMasked().

## isReduced_p

Bool casacore::LELAttribute::isReduced_p

private

Definition at line 140 of file LELAttribute.h.

Referenced by isReduced().

## isRegion_p

Bool casacore::LELAttribute::isRegion_p

private

Definition at line 141 of file LELAttribute.h.

Referenced by isRegion().

## isScalar_p

Bool casacore::LELAttribute::isScalar_p

private

Definition at line 139 of file LELAttribute.h.

Referenced by isScalar().

## shape_p

IPosition casacore::LELAttribute::shape_p

private

Definition at line 143 of file LELAttribute.h.

Referenced by shape().

## tileShape_p

IPosition casacore::LELAttribute::tileShape_p

private

Definition at line 144 of file LELAttribute.h.

Referenced by tileShape().

The documentation for this class was generated from the following file:

- lattices/LEL/LELAttribute.h